package com.zestia.mobile.customurlscheme;

import android.content.Intent;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaActivity;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.PluginResult;
import org.json.JSONArray;
import org.json.JSONException;

public class CustomURLSchemePlugin extends CordovaPlugin {
    private static final String ACTION_CHECKINTENT = "checkIntent";

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (ACTION_CHECKINTENT.equalsIgnoreCase(action)) {
            final Intent intent = ((CordovaActivity) this.webView.getContext()).getIntent();
            final String intentString = intent.getDataString();

            if (intentString != null && intent.getScheme() != null) {
                callbackContext.sendPluginResult(new PluginResult(PluginResult.Status.OK, intent.getDataString()));
            }

            return true;
        }

        return false;
    }

    @Override
    public void onNewIntent(Intent intent) {
        final String intentString = intent.getDataString();

        if (intentString != null && intent.getScheme() != null) {
            webView.loadUrl("javascript:handleOpenURL('" + intentString + "');");
        }
    }
}
